itech_av4/protected/models/Equipment.php
<?php

class Equipment extends CActiveRecord
{
	public $search_only_fa = false;
	public $equipment_type_name_search;
	public $room_id_search;
	public $room_name_search;
	public $room_filter;
	public $equipment_type_filter;
	public $onlyComAndVisual = false;
	public $search_text;
	public $search_text2;
	
	/**
	 * Returns the static model of the specified AR class.
	 * @return CActiveRecord the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'equipment';
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
				'equipment_type' => array(self::BELONGS_TO, 'EquipmentType', 'equipment_type_id'),
				'room' => array(self::BELONGS_TO, 'Room', 'room_id'),
				'equipment_type_list' => array(self::BELONGS_TO, 'EquipmentTypeList', 'equipment_type_list_id'),
		);
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules() {
		return array(
				array('equipment_type_name_search, room_name_search', 'safe', 'on'=>'search'),
				array('equipment_type_id, name, description, ip_address,mac_address,client_user,client_pass, room_id, status,barcode,img_path', 'safe'),
				//array('equipment_code, equipment_type_id, name, description, ip_address,mac_address,client_user,client_pass, room_id, status,barcode', 'safe'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
				'id' => 'ID',
// 				'equipment_code' => 'Code',
				'name' => 'Name',
				'description' => 'Description',
				'ip_address' => 'IP Address',
				'mac_address' => 'MAC Address',
				'client_user' => 'Client User',
				'client_pass' => 'Client Password',
				'status' => 'Status',
		);
	}

	/**
	 * @param Post the post that this comment belongs to. If null, the method
	 * will query for the post.
	 * @return string the permalink URL for this comment
	 */
	public function getUrl($post=null)
	{
		if($post===null)
			$post=$this->post;
		return $post->url.'#c'.$this->id;
	}

	/**
	 * This is invoked before the record is saved.
	 * @return boolean whether the record should be saved.
	 */
	protected function beforeSave()
	{
		
		/*
		 if(parent::beforeSave())
		 {
		if($this->isNewRecord)
			$this->create_time=time();
		return true;
		}
		else
			return false;
		*/
		
		return true;
	}

	public function search()
	{
		$criteria = new CDbCriteria;

		$criteria->with = array('equipment_type','room');
		if($this->room_filter != '') {
			$criteria->addCondition("t.room_id='".$this->room_filter."'");
		}
		if($this->search_text != '') {
			$criteria->addCondition("room.name LIKE '%".$this->search_text."%' OR t.name LIKE '%".$this->search_text."%' OR t.ip_address LIKE '%".$this->search_text."%' OR t.barcode LIKE '%".$this->search_text."%' OR equipment_type.name LIKE '%".$this->search_text."%' ");
		}
		if($this->room_id_search != '') {
			$criteria->addCondition("t.room_id='".$this->room_id_search."'");
		}		
		
		if($this->equipment_type_filter != '') {
			$criteria->addCondition("t.equipment_type_id='".$this->equipment_type_filter."'");
		}
		if($this->onlyComAndVisual) {
			$criteria->addCondition("(t.equipment_type_id='8' OR t.equipment_type_id='9')");
		}
		
		if($this->search_only_fa) {
			$criteria->addCondition("(t.room_id=2)");
		}
		
		$criteria->addCondition("(t.status='A')");
		
		/*
		if($this->search_text != '') {
			$criteria->addCondition("
					t.name LIKE '%".$this->search_text."%' OR
					t.ip_address LIKE '%".$this->search_text."%' OR
					equipment_type.name LIKE '%".$this->search_text."%' OR
					room.name LIKE '%".$this->search_text."%'");
		}
		*/
		
		return new CActiveDataProvider(get_class($this), array(
				'criteria' => $criteria,
				'sort' => array(
						'defaultOrder' => 't.name',
						'attributes'=>array(
								'equipment_type_name_search'=>array(
										'asc'=>'equipment_type.name',
										'desc'=>'equipment_type.name DESC',
								),
								'room_name_search'=>array(
										'asc'=>'room.name',
										'desc'=>'room.name DESC',
								),
								'*',
						),
				),
				'pagination' => array(
						'pageSize' => ConfigUtil::getDefaultPageSize()
				),
		));
	}
	

}

itech_av4/protected/models/EquipmentType.php
<?php

class EquipmentType extends CActiveRecord
{

	public $request_find_date;
	public $search_text;
	/**
	 * Returns the static model of the specified AR class.
	 * @return CActiveRecord the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'equipment_type';
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
				'equipment' => array(self::HAS_MANY, 'Equipment', 'equipment_type_id'),
				//'equipment_type_list' => array(self::BELONGS_TO, 'EquipmentTypeList', 'equipment_type_list_id'),
		);
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules() {
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
				array('equipment_type_code, name, description', 'safe'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
				'id' => 'ID',
				'equipment_type_code' => 'Code',
				'name' => 'Name',
				'description' => 'Description',
		);
	}

	/**
	 * @param Post the post that this comment belongs to. If null, the method
	 * will query for the post.
	 * @return string the permalink URL for this comment
	 */
	public function getUrl($post=null)
	{
		if($post===null)
			$post=$this->post;
		return $post->url.'#c'.$this->id;
	}

	/**
	 * This is invoked before the record is saved.
	 * @return boolean whether the record should be saved.
	 */
	protected function beforeSave()
	{
		/*
		 if(parent::beforeSave())
		 {
		if($this->isNewRecord)
			$this->create_time=time();
		return true;
		}
		else
			return false;
		*/
		return true;
	}

	public function search()
	{
		$criteria = new CDbCriteria;
		// Make not find self account
		if($this->search_text != '') {
			$criteria->addCondition("t.name LIKE '%".$this->search_text."%' OR
					t.equipment_type_code LIKE '%".$this->search_text."%'");
		}
		return new CActiveDataProvider(get_class($this), array(
				'criteria' => $criteria,
				'sort' => array(
						'defaultOrder' => 'id DESC',
				),
				'pagination' => array(
						'pageSize' => ConfigUtil::getDefaultPageSize()
				),
		));
	}
}

itech_av4/protected/controllers/EquipmentController.php
<?php

/**
 * SiteController is the default controller to handle user requests.
 */
class EquipmentController extends CController
{
	public $layout='management';
	private $_model;

	/**
	 * Index action is the default action in a controller.
	 */
	public function actionIndex()
	{
		// Permission
		if(!UserLoginUtil::hasPermission(array("FULL_ADMIN", "VIEW_EQUIPMENT", "CREATE_EQUIPMENT", "UPDATE_EQUIPMENT", "DELETE_EQUIPMENT"))){
			throw new CHttpException(404,Yii::t('yii','The system is unable to find the requested',
					array('{action}'=>$actionID==''?$this->defaultAction:$actionID)));
		}

		$model = new Equipment();

		// Set Search Text
		if(isset($_GET['search_text'])){
			$model->search_text = addslashes($_GET['search_text']);
		}




		if(isset($_POST['Equipment'])){

			//'C:\app\G.FAA List with service.xls';
			$upload_path = realpath(Yii::app()->basePath . '/../upload');
			$file = $upload_path.$_POST['Equipment']['file_path'];

			/*
			 * Upload
			* */
			Yii::import('ext.phpexcelreader.JPhpExcelReader');
			$data = new JPhpExcelReader($file);
			$num_row = $data->rowcount() + 1;


			//Insert user

			$tmpName = "";
			$tmpId = 0;
			while($index != $num_row){
				if($index>1){

					$order = $data->val($index, 'A');
					$groupCode = $data->val($index, 'C');
					$name = $data->val($index, 'D');
					$band = $data->val($index, 'F');
					$barcode = $data->val($index, 'G');
					$room = $data->val($index, 'H');

					$criteria1 = new CDbCriteria;
					$criteria1->condition="barcode = '".$barcode."'";
					$equip = Equipment::model()->findAll($criteria1);

					if(!isset($equip[0])) {

						$criteria = new CDbCriteria;
						$criteria->condition="equipment_type_code = '".$groupCode."'";
						$equipmentType = EquipmentType::model()->findAll($criteria);
						if(isset($equipmentType[0])) {
							//Add Group
							if( $tmpName != $name ){
								$tmp = new EquipmentTypeList();
								$tmp->equipment_type_id = $equipmentType[0]->id;
								$tmp->name = $name;
								if( $tmp->save() ){
									$tmpName = $name;
									$tmpId = $tmp->id;
								}
							}

							$model = new Equipment();
							$model->equipment_type_id =$equipmentType[0]->id;
							$model->equipment_type_list_id =$tmpId;
							$model->room_id =$room;
							$model->name=$name;
							$model->description =$band;
							$model->status ="A";
							$model->barcode =$barcode;

							if($model->save()){

							}

						}
					}else{
// 						$equip->room_id =$room;
// 						$equip->name=$name;
// 						$equip->description =$band;
// 						if($equip->save()){

// 						}
					}

				}

				$index++;
			}


		}

		$this->render('main', array(
				'data' => $model,
		));

	}
	
	public function actionCreate()
	{
		// Permission
		if(!UserLoginUtil::hasPermission(array("FULL_ADMIN", "CREATE_USER"))){
			throw new CHttpException(404,Yii::t('yii','The system is unable to find the requested',
					array('{action}'=>$actionID==''?$this->defaultAction:$actionID)));
		}
		if(isset($_POST['Equipment'])){
			$model = new Equipment();
			$model->attributes = $_POST['Equipment'];
			if($model->save()){
				$this->redirect(Yii::app()->createUrl('Equipment/'));
			}
		}
		$this->render('create');

	}
	public function actionDelete()
	{
		// Permission
		if(!UserLoginUtil::hasPermission(array("FULL_ADMIN", "DELETE_USER"))){
			throw new CHttpException(404,Yii::t('yii','The system is unable to find the requested',
					array('{action}'=>$actionID==''?$this->defaultAction:$actionID)));
		}

		$model = $this->loadModel();
		$model->delete();

		$this->redirect(Yii::app()->createUrl('Equipment/'));
	}
	public function actionView()
	{
		// Permission
		if(!UserLoginUtil::hasPermission(array("FULL_ADMIN", "VIEW_EQUIPMENT"))){
			throw new CHttpException(404,Yii::t('yii','The system is unable to find the requested',
					array('{action}'=>$actionID==''?$this->defaultAction:$actionID)));
		}

		$model = $this->loadModel();
		$this->render('view', array(
				'model' => $model,
		));
	}
	public function actionUpdate()
	{
		// Permission
		if(!UserLoginUtil::hasPermission(array("FULL_ADMIN", "UPDATE_USER"))){
			throw new CHttpException(404,Yii::t('yii','The system is unable to find the requested',
					array('{action}'=>$actionID==''?$this->defaultAction:$actionID)));
		}

		$model = $this->loadModel();
		if(isset($_POST['Equipment'])){
			if($model->status == 'D') {
				if($_POST['Equipment']['status'] == 'A') {
					$equipmentCrackedLogs = EquipmentCrackedLog::model()->findAll(array('condition'=>"equipment_id = '".$model->id."' and status != 'S'"));
					if($equipmentCrackedLogs != null && count($equipmentCrackedLogs) > 0) {
						$equipmentCrackedLog = $equipmentCrackedLogs[0];
						$equipmentCrackedLog->status = 'S';
						$equipmentCrackedLog->update();
					}
				}
			} else {
				if($_POST['Equipment']['status'] == 'D') {
					$equipmentCrackedLog = new EquipmentCrackedLog();
					$equipmentCrackedLog->equipment_id = $model->id;
					$equipmentCrackedLog->cracked_date = date("Y-m-d");
					$equipmentCrackedLog->save();
				}
			}
			$model->attributes = $_POST['Equipment'];

			if($model->update()){
				$this->redirect(Yii::app()->createUrl('Equipment/'));
			}
		}
		$this->render('update', array(
				'model' => $model,
		));
	}

	public function actionUpload1()
	{
		//$this->redirect(Yii::app()->createUrl('http://www.kapook.com'));
		Yii::import("ext.EAjaxUpload.qqFileUploader");

		$folder='upload/';

		if (!is_dir($folder)) {
			mkdir($folder,0777,TRUE);
		}

		$allowedExtensions = array("jpg","png","xls");//array("jpg","jpeg","gif","exe","mov" and etc...
		$sizeLimit = 5 * 1024 * 1024;// maximum file size in bytes
		$uploader = new qqFileUploader($allowedExtensions, $sizeLimit);
		$result = $uploader->handleUpload($folder);
		$return = htmlspecialchars(json_encode($result), ENT_NOQUOTES);

		$fileSize=filesize($folder.$result['filename']);//GETTING FILE SIZE
		$fileName=$result['filename'];//GETTING FILE NAME

		echo $return;// it's array
	}

	public function actionUpload()
	{
		Yii::import("ext.EAjaxUpload.qqFileUploader");

		$folder=Yii::app()->basePath.'/../upload/';// folder for uploaded files

		$allowedExtensions = array("xls");//array("jpg","jpeg","gif","exe","mov" and etc...
		$sizeLimit = 10 * 1024 * 1024;// maximum file size in bytes
		$uploader = new qqFileUploader($allowedExtensions, $sizeLimit);
		$result = $uploader->handleUpload($folder);
		/*
		 * Upload
		* */
		Yii::import('ext.phpexcelreader.JPhpExcelReader');
		$data=new JPhpExcelReader($folder.$result['filename']);
		$num_row = $data->rowcount() + 1;
		//Insert user

		$tmpName = "";
		$tmpId = 0;
		while($index != $num_row){
			if($index>1){

				$order = $data->val($index, 'A');
				$groupCode = $data->val($index, 'C');
				$name = $data->val($index, 'D');
				$band = $data->val($index, 'E');
				$barcode = $data->val($index, 'F');
				$room = $data->val($index, 'G');

				$criteria1 = new CDbCriteria;
				$criteria1->condition="barcode = '".$barcode."'";
				$equip = Equipment::model()->findAll($criteria1);

				if(!isset($equip[0])) {

					$criteria = new CDbCriteria;
					$criteria->condition="equipment_type_code = '".$groupCode."'";
					$equipmentType = EquipmentType::model()->findAll($criteria);
					if(isset($equipmentType[0])) {
						//Add Group
						if( $tmpName != $name ){
							$tmp = new EquipmentTypeList();
							$tmp->equipment_type_id = $equipmentType[0]->id;
							$tmp->name = $name;
							if( $tmp->save() ){
								$tmpName = $name;
								$tmpId = $tmp->id;
							}
						}

						$model = new Equipment();
						$model->equipment_type_id =$equipmentType[0]->id;
						$model->equipment_type_list_id =$tmpId;
						$model->room_id =$room;
						$model->name=$name;
						$model->description =$band;
						$model->status ="A";
						$model->barcode =$barcode;

						if($model->save()){
						}

					}
				}else{
					//echo "XXXXX".$equip[0]->id."<br>";
				}

			}

			$index++;
		}

		/**
		 *
		 * */

		$fileSize=filesize($folder.$result['filename']);//GETTING FILE SIZE
		$fileName=$result['filename'];//GETTING FILE NAME
		$result = htmlspecialchars(json_encode($result), ENT_NOQUOTES);

		echo $result;// it's array
	}


	public function loadModel()
	{
		if($this->_model===null)
		{
			if(isset($_GET['id']))
				$this->_model=Equipment::model()->findbyPk($_GET['id']);
			if($this->_model===null)
				throw new CHttpException(404,'The requested page does not exist.');
		}
		return $this->_model;
	}


}

itech_av4/protected/views/equipment/main.php
<link
	rel="stylesheet"
	href="<?php echo Yii::app()->request->baseUrl;?>/css/bootstrap.css">
<!-- Generic page styles -->
<link
	rel="stylesheet"
	href="<?php echo Yii::app()->request->baseUrl;?>/jQuery-File-Upload-8.2.1/css/style.css">
<!-- Bootstrap styles for responsive website layout, supporting different screen sizes -->
<link
	rel="stylesheet"
	href="<?php echo Yii::app()->request->baseUrl;?>/jQuery-File-Upload-8.2.1/css/jquery.fileupload-ui.css">
<script
	type="text/javascript"
	src="<?php echo Yii::app()->request->baseUrl;?>/js/ajax.js"></script>
<script
	type="text/javascript"
	src="<?php echo Yii::app()->request->baseUrl;?>/js/util.js"></script>
<script
	type="text/javascript"
	src="<?php echo Yii::app()->request->baseUrl;?>/jQuery-File-Upload-8.2.1/js/vendor/jquery.ui.widget.js"></script>
<script
	type="text/javascript"
	src="<?php echo Yii::app()->request->baseUrl;?>/jQuery-File-Upload-8.2.1/js/jquery.iframe-transport.js"></script>
<script
	type="text/javascript"
	src="<?php echo Yii::app()->request->baseUrl;?>/jQuery-File-Upload-8.2.1/js/jquery.fileupload.js"></script>
<script type="text/javascript">
$(function() {
    'use strict';
    // Change this to the location of your server-side upload handler:
    var time = '<?php echo time()?>';
    var url2 = '<?php echo Yii::app()->request->baseUrl;?>/upload/?folder=' + time;
   
    $('#fileupload').fileupload({
        url: url2,
        dataType: 'json',
        done: function (e, data) {
            $.each(data.result.files, function (index, file) {
                $('<p/>').text(file.name).appendTo('#files');
                $('#f_path').val('/files/' + time + '/' + file.name);
            });
            alert('Upload Complete.');
            $('#fileupload').hide();		            
        },
        progressall: function (e, data) {
            var progress = parseInt(data.loaded / data.total * 100, 10);
            $('#progress .bar').css(
                'width',
                progress + '%'
            );
        }
    });
});
</script>

<div class="module-head">Equipment</div>

<div>
	<br>
	<?php 
	if(UserLoginUtil::hasPermission(array("FULL_ADMIN", "CREATE_USER"))){
		echo CHtml::link('Create New',array('equipment/create'), array('class'=>'add'));
	}
	?>

	<div class="search-box">
		<?php 
		$form = $this->beginWidget('CActiveForm', array(
				'id' => 'equipment-form',
				'method'=>'get',
				'action'=>'',
				'enableAjaxValidation' => false,
		));
		?>
		<input type="text" name="search_text"
			value="<?php echo $_GET['search_text']?>">
		<?php $this->endWidget(); ?>
	</div>
	<br> <br>
</div>
<div class="simple-grid">
	<table class="items">
		<thead>
			<tr>
				<th width="5%">#</th>
				<!--<th width="15%">Code</th> -->
				<th width="45%">name</th>
				<th width="10%">ip_address</th>
				<th width="10%">Type</th>
				<th width="20%">Room</th>
				<th width="10%">Action</th>
			</tr>
		</thead>
		<tbody>
			<?php 
			$counter = 1;
			$dataProvider = $data->search();
			foreach ($dataProvider->data as $data) {
		?>
			<tr class="line-<?php echo $counter%2 == 0 ? '1' : '2'?>">
				<td class="center"><?php echo GridUtil::getDataIndex($dataProvider, $counter++)?>
				</td>
				<!-- <td class="center"><?php //echo $data->equipment_code?></td> -->
				<td class="left"><?php echo $data->name?></td>
				<td class="center"><?php echo $data->ip_address?></td>
				<td class="center"><?php echo $data->equipment_type->name?></td>
				<td class="left"><?php echo $data->room->name?></td>
				<td class="center"><a title="View" class="ico-s-view"
					href="<?php echo Yii::app()->CreateUrl('Equipment/view/id/'.$data->id)?>"></a>
					<a title="Edit" class="ico-s-edit"
					href="<?php echo Yii::app()->CreateUrl('Equipment/update/id/'.$data->id)?>"></a>
					<a title="Delete"
					onclick="return confirm('Are you sure to delete?')"
					class="ico-s-delete"
					href="<?php echo Yii::app()->CreateUrl('Equipment/delete/id/'.$data->id)?>"></a>
				</td>
			</tr>
			<?php 
		}
		?>
		</tbody>
	</table>
	<div class="paging">
		<?php GridUtil::RenderPageButton($this, $dataProvider); ?>
	</div>
</div>
<?php 
$form = $this->beginWidget('CActiveForm', array(
			'id' => 'users-form',
			'enableAjaxValidation' => true,
			'htmlOptions'=>array('enctype' => 'multipart/form-data')
	));
	?>
<table>
	<tr>
		<td class="column-left">File</td>
		<td class="column-right"><span> <input id="fileupload" type="file"
				name="files[]">
		</span> <br> <br> <!-- The global progress bar -->
			<div id="progress" class="progress progress-success progress-striped">
				<div class="bar"></div>
			</div> <!-- The container for the uploaded files -->
			<div id="files"></div> <input type="hidden" id="f_path"
			name="Equipment[file_path]" value="">
		</td>
		<td><input type="submit" value="Import" /></td>
	</tr>
</table>
<?php $this->endWidget(); ?>







itech_av4/protected/views/equipment/view.php
<div class="module-head">Equipment</div>
<table class="simple-form">
	<tr>
		<td class="column-left" width="15%">Code</td>
		<td class="column-right"><?php echo $model->id ?>
		</td>
	</tr>
	<tr>
		<td class="column-left">Type</td>
		<td class="column-right"><?php echo $model->equipment_type->name ?></td>
	</tr>
		<tr>
		<td class="column-left">Room</td>
		<td class="column-right"><?php echo $model->room->name ?></td>
	</tr>
		<tr>
		<td class="column-left">Name</td>
		<td class="column-right"><?php echo $model->name ?></td>
	</tr>
	<tr>
		<td class="column-left">Description</td>
		<td class="column-right"><?php echo $model->description ?></td>
	</tr>
	<tr>
		<td class="column-left">IP Address</td>
		<td class="column-right"><?php echo $model->ip_address ?></td>
	</tr>
	<tr>
		<td class="column-left">MAC Address</td>
		<td class="column-right"><?php echo $model->mac_address ?></td>
	</tr>	
	<tr>
		<td class="column-left">Client User</td>
		<td class="column-right"><?php echo $model->client_user ?></td>
	</tr>	
	<tr>
		<td class="column-left">Client Password</td>
		<td class="column-right"><?php echo $model->client_pass ?></td>
	</tr>			
	<tr>
		<td class="column-left">Status</td>
		<td class="column-right"><?php echo $model->status == 'A' ? 'Normal' : 'Cracked' ?></td>
	</tr>
	<tr>
		<td class="column-left"></td>
		<td class="column-right"><?php 
		echo CHtml::link('Back',array('equipment/')).' | '; echo
		CHtml::link('Edit',array('equipment/update','id'=>$model->id)); ?>
		</td>
	</tr>
</table>
